@REM Copyright IBM Corp. 2004
@REM
@REM THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
@REM All Rights Reserved * Licensed Materials - Property of IBM
@REM US Government Users Restricted Rights - Use, duplication or disclosure
@REM restricted by GSA ADP Schedule Contract with IBM Corp.

@echo off
if "%~1"=="5022" goto UpdateStart5022
if "%~1"=="5023" goto UpdateStart5023

@rem added to allow user specified install dir
if "%~1"=="-in" ( 
if exist "%~2" (
set WSXD_DIR_LONG=%~2
goto dir_set
)
)

setlocal
cd /d "%~dp0"
call util\SetEnvFromReg TOOLKIT_UNINSTALLER "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\PortalToolkit5022Product" "UninstallString"
if "%TOOLKIT_UNINSTALLER%"=="" call util\SetEnvFromReg TOOLKIT_UNINSTALLER "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\PortalToolkit5023Product" "UninstallString"
if "%TOOLKIT_UNINSTALLER%"=="" call util\SetEnvFromReg TOOLKIT_UNINSTALLER "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\PortalUTE50" "UninstallString"
if "%TOOLKIT_UNINSTALLER%"=="" goto no_wps5021

for %%i in ("%TOOLKIT_UNINSTALLER%") do set TKUNINST_DIR=%%~dpi
pushd "%TKUNINST_DIR%..\.."
set WSXD_DIR_LONG=%CD%
popd

:dir_set

"%~dp0util\ShortPath" "%WSXD_DIR_LONG%">%TEMP%\SP.tmp
for /f %%i in ( %TEMP%\SP.tmp ) do set WSXD_DIR=%%i
del %TEMP%\SP.tmp

if exist %WSXD_DIR%\PortalToolkit set TOOLKIT_DIR=%WSXD_DIR%\PortalToolkit
if exist %WSXD_DIR%\PortalUTE50 set TOOLKIT_DIR=%WSXD_DIR%\PortalUTE50

set WAS_DIR=%WSXD_DIR%\runtimes\portal_base_v5
set WPS_DIR=%WSXD_DIR%\runtimes\portal_v50
set WPS_DIR_LONG=%WSXD_DIR_LONG%\runtimes\portal_v50
set PATH=%WSXD_DIR%\runtimes\base_v5\java\bin;%WAS_DIR%\java\bin;%PATH%
set JAVA_UTIL=java -classpath "%CD%\util\util.jar;%WSXD_DIR%\runtimes\base_v5_stub\lib\j2ee.jar;%WSXD_DIR%\runtimes\base_v5_stub\lib\xerces.jar" com.ibm.etools.portal.install.Util
set JAVA_LOG=java -classpath "%CD%\util\util.jar" com.ibm.etools.portal.install.Log2
set LOG=%TEMP%\%~n0Temp.log
set TEMP_DIR=%TEMP%\%~n0

if exist "%WPS_DIR%\version\WP_PTF_5023.ptf" goto already

if not exist "WTE_setup\was502_cf6_win.zip" goto no_prereq_file
if not exist "WTE_setup\was502_jdk_win.zip" goto no_prereq_file
if not exist "WTE_setup\PortalUpdateInstaller.zip" goto no_prereq_file
if not exist "WTE_setup\WP_PTF_5022.jar" goto no_prereq_file
if not exist "WTE_setup\WP_PTF_5023.jar" goto no_prereq_file

echo.
echo WebSphere Portal in the following location will be upgraded.
echo   %WPS_DIR_LONG%
echo.
pause

%JAVA_UTIL% isStringFoundInFile "%WPS_DIR%\wps.properties" "version=5.0.2.1"
if not ERRORLEVEL 1 (
"%~f0" 5022 %* logging 2>&1 | %JAVA_LOG% "%TOOLKIT_DIR%\log\TkWpsInst.log"
echo WebSphere Portal has been upgraded successfully.
exit /B
)
%JAVA_UTIL% isStringFoundInFile "%WPS_DIR%\wps.properties" "version=5.0.2.2"
if not ERRORLEVEL 1 (
"%~f0" 5023 %* logging 2>&1 | %JAVA_LOG% "%TOOLKIT_DIR%\log\TkWpsInst.log"
echo WebSphere Portal has been upgraded successfully.
exit /B
)
if ERRORLEVEL 1 goto no_wps5021

exit /B

:UpdateStart5022
@echo ---- %~nx0 Started. %DATE% %TIME% ----
echo on
setlocal
set PROMPT=$T]$P$G

rem File information
rem %0 %~t0 %~z0 bytes

dir "%~dp0WTE_setup"

rem Pre Step 1 - Verify WAS 5023 or higher - Install WAS 502 CF6(5.0.2.6)

    rem Fix WAS fix files for WSAD
    if exist "%WAS_DIR%\properties\version\backup" goto fix_undo_jar_done
        if exist "%WAS_DIR%\properties\version\backup" rd "%WAS_DIR%\properties\version\backup" /s /q
        xcopy "%~dp0was_image\properties\version\backup\*" "%WAS_DIR%\properties\version\backup" /i /s /e /r /h /y>nul
        if exist "%WAS_DIR%\properties\version\history" rd "%WAS_DIR%\properties\version\history" /s /q
        xcopy "%~dp0was_image\properties\version\history\*" "%WAS_DIR%\properties\version\history" /i /s /e /r /h /y>nul

        set OLD_WAS_FP_DIR=C:\Program Files\WebSphere\AppServer
        if exist "%TEMP_DIR%" rd "%TEMP_DIR%" /s /q
        md "%TEMP_DIR%"
        pushd "%WAS_DIR%\properties\version\history"
        for %%f in (event.history PQ81248.efixApplied PQ81416.efixApplied PQ81989_win.efixApplied WAS_Adapter_10-30-2003_5.0.2_cumulative_Fix.efixApplied WAS_CM_08-12-2003_5.0.2-5.0.1_cumulative_Fix.efixApplied WAS_Dynacache_01-30-2004_5.0.2_cumulative_fix.efixApplied WAS_Security_12-13-2003_5.0.2.3-5.0.2.2-5.0.2.1-5.0.2-5.0.1-5.0.0_JSSE_cumulative_Fix.efixApplied) do %JAVA_UTIL% replaceStringInFileUTF8 "%%~f" "%TEMP_DIR%\%%~f.tkb" "%OLD_WAS_FP_DIR%" "%WAS_DIR%"
        popd
        pushd "%TEMP_DIR%"
        for %%f in (20040721_150439_PQ81248_httpsession_undo.jar 20040721_150439_WAS_Adapter_10-30-2003_5.0.2_cumulative_Fix_adapter_undo.jar 20040721_150440_WAS_CM_08-12-2003_5.0.2-5.0.1_cumulative_Fix_cm.impl_undo.jar 20040721_150440_WAS_Security_12-13-2003_5.0.2.3-5.0.2.2-5.0.2.1-5.0.2-5.0.1-5.0.0_JSSE_cumulative_Fix_prereq.jsse_undo.jar 20040721_150441_PQ81416_httpsession_undo.jar 20040721_150441_WAS_CM_08-12-2003_5.0.2-5.0.1_cumulative_Fix_cm.int_undo.jar 20040721_150441_WAS_Dynacache_01-30-2004_5.0.2_cumulative_fix_dynacache_undo.jar 20040721_150452_PQ81989_win_prereq.jdk_undo.jar) do call :fix_undo_jar "%%~f"
        popd
        rd "%TEMP_DIR%" /s /q
    :fix_undo_jar_done

    rem Apply WAS cumulative fix 6.
    setlocal
    pushd "%WAS_DIR%\bin"
    call setupCmdLine.bat
    popd
    if exist "%TEMP_DIR%" rd "%TEMP_DIR%" /s /q
    md "%TEMP_DIR%"
    pushd "%TEMP_DIR%"
    jar xf "%~dp0WTE_setup\was502_cf6_win.zip"
    call updateSilent -fixpack -install -installDir "%WAS_DIR%" -fixpackDir fixpacks -fixpackID was502_cf6_win -skipIHS -skipMQ
    @echo on
    popd
    rd "%TEMP_DIR%" /s /q
    endlocal

    rem Apply fixpacks.
    setlocal
    pushd "%WAS_DIR%\bin"
    call setupCmdLine.bat
    popd
    if exist %TEMP%\pute rd %TEMP%\pute /s /q
    md "%TEMP_DIR%"
    pushd "%TEMP_DIR%"
    jar xf "%~dp0WTE_setup\was502_jdk_win.zip"
    call updateSilent -fixpack -install -installDir "%WAS_DIR%" -fixpackDir fixpacks -fixpackID was502_jdk_win -skipIHS -skipMQ
    @echo on
    popd
    rd "%TEMP_DIR%" /s /q
    endlocal

rem Pre Step 2 - Verify required HW/SW
rem Pre Step 3 - Verify wpconfig.properties is correct
rem Pre Step 4 - Verify required WAS fixes are installed - No WAS fixes are required for WAS 5.0.2.6
rem Pre Step 5 - Stop Web Server if you are running one
rem Pre Step 6 - Comment out lines in httpd.conf
rem Pre Step 7 - Export the db2instance environment for DB2 on UNIX
rem Pre Step 8 - Settings to reduce deadlocks
rem Pre Step 9 - Verify that sufficient disk space is available

rem Step 1 - Set up the Java environment
    pushd "%WAS_DIR%\bin"
    call setupCmdLine.bat
    popd
rem Step 1 end

rem Step 2 - Stop all active application servers
    pushd "%WAS_DIR%\bin"
    call stopServer server1
    @echo on
    call stopServer WebSphere_Portal
    @echo on
    popd
rem Step 2 end

rem Step 3 - Change the timeout request
    %JAVA_UTIL% modifyPropertiesFile "%WAS_DIR%\properties\soap.client.props" "%WAS_DIR%\properties\soap.client.props.tkb" "com.ibm.SOAP.requestTimeout=6000"
    if not exist "%WAS_DIR%\properties\soap.client.props.tkb" goto error
rem Step 3 end

    rem Make WAS temporary directory path shorter to avoid the deployment error
    set TKTMP=%SystemDrive%\__TKWAS__
    if not exist "%TKTMP%" md "%TKTMP%"
    %JAVA_UTIL% modifyServerXML "%WAS_DIR%\config\cells\localhost\nodes\localhost\servers\WebSphere_Portal\server.xml" "%TKTMP%"

rem Step 4 - Run installer
    md "%TEMP_DIR%"
    pushd "%TEMP_DIR%"
    jar xf "%~dp0WTE_setup\PortalUpdateInstaller.zip"
    call "%TEMP_DIR%\updatePortal.bat" -fixpack -installDir "%WPS_DIR%" -fixpackDir "%~dp0WTE_setup" -install -fixpackID WP_PTF_5022 2>&1 | %JAVA_LOG% "%LOG%"
    @echo on
    %JAVA_UTIL% isStringFoundInFile "%LOG%" "Fix pack installation completed successfully."
    if ERRORLEVEL 1 goto error
    del "%LOG%"
    popd
    rd "%TEMP_DIR%" /s /q
rem Step 4 end

rem Step 5 - Restart the Web server if you are using one.
rem Step 5 end

rem Step 6 - Run configuration
    if exist "%WAS_DIR%\properties\version\PME.product" goto wpsconfig_ee
        rem Remove WPCP related lines from WP_PTF_5022.xml
        %JAVA_UTIL% replaceStringInFile "%WPS_DIR%\config\includes\WP_PTF_5022.xml" "%WPS_DIR%\config\includes\WP_PTF_5022.xml.tub" "<antcall target=\"action-config-WPCP-PDM-ODC-5021\"/>" ""
        type "%WPS_DIR%\config\includes\WP_PTF_5022.xml"
    :wpsconfig_ee

    call :wps_config WP-PTF-5022
    set RC=%ERRORLEVEL%
rem Step 6 end

rem Step 7 - Restart WAS
rem Step 7 end

rem Step 8 - Restart WPS
rem Step 8 end

rem Stop servers
    pushd "%WAS_DIR%\bin"
    call stopServer server1
    @echo on
    call stopServer WebSphere_Portal
    @echo on
    popd

rem Restore the timeout request
    del "%WAS_DIR%\properties\soap.client.props"
    ren "%WAS_DIR%\properties\soap.client.props.tkb" "soap.client.props"

rem Restore WAS temporary directory path
    del "%WAS_DIR%\config\cells\localhost\nodes\localhost\servers\WebSphere_Portal\server.xml"
    ren "%WAS_DIR%\config\cells\localhost\nodes\localhost\servers\WebSphere_Portal\server.xml.tkb" "server.xml"
    rd  "%TKTMP%" /S /Q

    if not "%RC%"=="0" goto error

rem Disable Transcoding
    %JAVA_UTIL% modifyPropertiesFile "%WPS_DIR%\shared\app\config\services\PortalFilterService.properties" "%WPS_DIR%\shared\app\config\services\PortalFilterService.properties.tkb" "#DisableTranscoding :filtername1" "#DisableTranscoding :wml.classname" "#DisableTranscoding :filtername2" "#DisableTranscoding :chtml.classname" "#DisableTranscoding :filtername3" "#DisableTranscoding :vxml.classname"

    %JAVA_UTIL% modifyPropertiesFile "%WPS_DIR%\shared\app\config\services\PortletFilterService.properties" "%WPS_DIR%\shared\app\config\services\PortletFilterService.properties.tkb" "#DisableTranscoding :filtername1" "#DisableTranscoding :Transcoding.classname" "#DisableTranscoding :Transcoding.transcodeMarkup.1" "#DisableTranscoding :Transcoding.transcodeMarkup.2" "#DisableTranscoding :Transcoding.transcodeMarkup.3"

    %JAVA_UTIL% modifyPropertiesFile "%WPS_DIR%\shared\app\config\services.properties" "%WPS_DIR%\shared\app\config\services.properties.tkb" "#DisableTranscoding :com.ibm.transform.wps.TranscodingService"

rem Enable JSR 168
    %JAVA_UTIL% modifyPropertiesFile "%WPS_DIR%\shared\app\config\services\ConfigService.properties" "%WPS_DIR%\shared\app\config\services\ConfigService.properties.tkb" "portal.enable.jsr168=true"

rem Disable cache error messages
    %JAVA_UTIL% modifyPropertiesFile "%WPS_DIR%\shared\app\config\services\CacheManagerService.properties" "%WPS_DIR%\shared\app\config\services\CacheManagerService.properties.tkb" "cacheglobal.active.txcache=false"

rem Disable parallel rendering
    %JAVA_UTIL% modifyPropertiesFile "%WPS_DIR%\shared\app\config\services\PortletContainerService.properties" "%WPS_DIR%\shared\app\config\services\PortletContainerService.properties.tkb" "legacy.useParallelRendering=false" "std.useParallelRendering=false"

rem Get the portlet list and update wpsdebug.v5\plugin.xml
    pushd "%WAS_DIR%\config\cells\localhost\applications"
    dir /ad /b>"%TOOLKIT_DIR%\configuredPortlets"
    popd
    for /d %%d in ( "%WSXD_DIR%\portaltools\eclipse\plugins\com.ibm.etools.portal.server.tools.v5_*" ) do set DEBUG_PLUGIN_DIR=%%d
    %JAVA_UTIL% modifyDebugPluginXML "%DEBUG_PLUGIN_DIR%\plugin.xml" "%TOOLKIT_DIR%\initialPortlets" "%TOOLKIT_DIR%\configuredPortlets"

:UpdateStart5023
@echo ---- %~nx0 Started. %DATE% %TIME% ----
echo on
setlocal
set PROMPT=$T]$P$G

rem File information
rem %0 %~t0 %~z0 bytes

rem Step 1 - Set up the Java environment
    pushd "%WAS_DIR%\bin"
    call setupCmdLine.bat
    popd
rem Step 1 end

rem Step 2 - Stop all active application servers
    pushd "%WAS_DIR%\bin"
    call stopServer server1
    @echo on
    call stopServer WebSphere_Portal
    @echo on
    popd
rem Step 2 end

rem Step 3 - Change the timeout request
    %JAVA_UTIL% modifyPropertiesFile "%WAS_DIR%\properties\soap.client.props" "%WAS_DIR%\properties\soap.client.props.tkb" "com.ibm.SOAP.requestTimeout=6000"
    if not exist "%WAS_DIR%\properties\soap.client.props.tkb" goto error
rem Step 3 end

    rem Make WAS temporary directory path shorter to avoid the deployment error
    set TKTMP=%SystemDrive%\__TKWAS__
    if not exist "%TKTMP%" md "%TKTMP%"
    %JAVA_UTIL% modifyServerXML "%WAS_DIR%\config\cells\localhost\nodes\localhost\servers\WebSphere_Portal\server.xml" "%TKTMP%"

rem Step 4 - Run installer
    md "%TEMP_DIR%"
    pushd "%TEMP_DIR%"
    jar xf "%~dp0WTE_setup\PortalUpdateInstaller.zip"
    call "%TEMP_DIR%\updatePortal.bat" -fixpack -installDir "%WPS_DIR%" -fixpackDir "%~dp0WTE_setup" -install -fixpackID WP_PTF_5023 2>&1 | %JAVA_LOG% "%LOG%"
    @echo on
    %JAVA_UTIL% isStringFoundInFile "%LOG%" "Fix pack installation completed successfully."
    if ERRORLEVEL 1 goto error
    del "%LOG%"
    popd
    rd "%TEMP_DIR%" /s /q
rem Step 4 end

rem Step 5 - Restart the Web server if you are using one.

rem Step 5 end

rem Step 6 - Run configuration
    if exist "%WAS_DIR%\properties\version\PME.product" goto wpsconfig_ee
        rem Remove WPCP related lines from WP_PTF_5022.xml
        %JAVA_UTIL% replaceStringInFile "%WPS_DIR%\config\includes\WP_PTF_5022.xml" "%WPS_DIR%\config\includes\WP_PTF_5022.xml.tub" "<antcall target=\"action-config-WPCP-PDM-ODC-5021\"/>" ""
        type "%WPS_DIR%\config\includes\WP_PTF_5022.xml"
    :wpsconfig_ee

    call :wps_config UTE-WP-PTF-5023
    set RC=%ERRORLEVEL%
rem Step 6 end

rem Step 7 - Restart WAS
rem Step 7 end

rem Step 8 - Restart WPS
rem Step 8 end

rem Stop servers
    pushd "%WAS_DIR%\bin"
    call stopServer server1
    @echo on
    call stopServer WebSphere_Portal
    @echo on
    popd

rem Restore the timeout request
    del "%WAS_DIR%\properties\soap.client.props"
    ren "%WAS_DIR%\properties\soap.client.props.tkb" "soap.client.props"

rem Restore WAS temporary directory path
    del "%WAS_DIR%\config\cells\localhost\nodes\localhost\servers\WebSphere_Portal\server.xml"
    ren "%WAS_DIR%\config\cells\localhost\nodes\localhost\servers\WebSphere_Portal\server.xml.tkb" "server.xml"
    rd  "%TKTMP%" /S /Q

    if not "%RC%"=="0" goto error

endlocal
type "%WPS_DIR%\wps.properties"
@echo ---- %~nx0 Ended. (Successful) %DATE% %TIME% ----
exit /B 0

:error
endlocal
type "%WPS_DIR%\wps.properties"
if exist "%LOG%" del "%LOG%"
echo ---- %~nx0 Ended. (Error) %DATE% %TIME% ----
echo Failed to upgrade WebSphere Portal. Refer to the log.
exit /B 1

:no_prereq_file
echo.
echo This tool requires the following files. Refer to the installation guide.
echo   WTE_setup\was502_cf6_win.zip
echo   WTE_setup\was502_jdk_win.zip
echo   WTE_setup\PortalUpdateInstaller.zip
echo   WTE_setup\WP_PTF_5022.jar
echo   WTE_setup\WP_PTF_5023.jar
echo.
pause
exit /B 1

:already
echo.
echo The fix pack is already installed.
echo.
pause
exit /B 1

:no_wps5021
echo.
echo WebSphere Portal 5.0.2.1 is not installed.
echo.
pause
exit /B 1

rem Sub-routine
:xml_access
    pushd "%WPS_DIR%"
    call bin\xmlaccess -in %* -user wpsadmin -pwd wpsadmin -url http://localhost:9081/wps/config 2>&1 | %JAVA_LOG% "%LOG%"
    @echo on
    popd
    %JAVA_UTIL% isStringFoundInFile "%LOG%" "status element=\"all\" result=\"ok\""
    if ERRORLEVEL 1 exit /B 1
    del "%LOG%"
    exit /B 0

:wps_config
    pushd "%WPS_DIR%\config"
    call WPSconfig.bat %* 2>&1 | %JAVA_LOG% "%LOG%"
    @echo on
    popd
    %JAVA_UTIL% isStringFoundInFile "%LOG%" "BUILD SUCCESSFUL"
    if ERRORLEVEL 1 exit /B 1
    del "%LOG%"
    exit /B 0

:fix_undo_jar
    jar xf "%WAS_DIR%\properties\version\backup\%~1" META-INF/MANIFEST.MF
    %JAVA_UTIL% replaceStringInFile "META-INF\MANIFEST.MF" "META-INF\MANIFEST.MF.tkb" "%OLD_WAS_FP_DIR%" "%WAS_DIR%"
    del META-INF\*.tkb
    jar ufM "%WAS_DIR%\properties\version\backup\%~1" META-INF/MANIFEST.MF
    exit /B 1
